#include <stdio.h>

typedef char *va_list;

#define va_start(ap, last) (void)((ap)=(va_list)&(last)+sizeof(last))
#define va_arg(ap, type) (*((type *)(ap))++)
#define va_end(ap) (void)((ap)=NULL)


int caos_printf(const char *format, ...);
int print_dword(char *, int a, char flag);
int caos_vsprintf(char *A_szString, const char *A_szFormat, va_list A_pAp);
int caos_strcat(char *A_szDest, char *A_szSrc);


int caos_printf(const char *format, ...)
{
		va_list ap;
		int temp;
		char sz[1024];

		va_start(ap, format);
		temp = caos_vsprintf(sz, format, ap);
		va_end(ap);

		printf("%s\n", sz);

		return temp;
}


int caos_strcat(char *A_szDest, char *A_szSrc)
{
		char *p = A_szSrc;
		while (*A_szSrc != '\0')
				*A_szDest++ = *A_szSrc++;
		return A_szSrc-p;
}

int caos_vsprintf(char *A_szString, const char *A_szFormat, va_list A_pAp)
{
		int temp;
		

		while (*A_szFormat != '\0') {
				if (*A_szFormat == '%' && ( *(A_szFormat+1) == 'd' || *(A_szFormat+1) == 'x' )) {
						temp = va_arg(A_pAp, int);
						temp = print_dword(A_szString, temp, *(A_szFormat+1));
						A_szString += temp;
						A_szFormat += 2;
				} else if (*A_szFormat == '%' && *(A_szFormat+1) == 's') {
						temp = caos_strcat(A_szString, va_arg(A_pAp, char *));
						A_szString += temp;
						A_szFormat += 2;
				} else if (*A_szFormat == 0xa /*&& *(A_szFormat+1) == 0xd*/) {
						/* new linw */
						temp = 344;
						printf("%f ", (temp/160+1)*160);
						printf("new line!");
						A_szFormat += 1;
				} else {
						*A_szString++ = *A_szFormat++;
				}
		}
		*A_szString = '\0';

		return 0;
}


int print_dword(char *A_szBuffer, int a, char flag)
{
		unsigned char *p;
		unsigned char v[10];
		int i = 0;
		int count = 0;
		
		if (flag == 'd') {
				/* print signed integer */
				if (a & 0x80000000) {
						/* print minus */
						putchar('-');
						a = -a;
				}
				
				while (a > 0) {
						v[i++] = a % 10;
						a /= 10;
				}

				for (--i; i >= 0; i--) {
						if (v[i] != 0) {
								*A_szBuffer++ = v[i]+0x30;
								count++;
						}
				}
				
		} else if (flag == 'x') {
				/* print hexa decimal */
				p = (char *)&a;
				for (i = sizeof(int); i > 0; i--) {
						if (p[i-1] == 0x0)
								continue;
						count++;
						if ( (p[i-1] >> 4) <= 9)
								*A_szBuffer++ = (p[i-1] >> 4) + 0x30;
						else 
								*A_szBuffer++ = (p[i-1] >> 4) + 0x37;

						count++;
						if ( (p[i-1] & 0x0f) <= 9)
								*A_szBuffer++ = (p[i-1] & 0x0f) + 0x30;
						else 
								*A_szBuffer++ = (p[i-1] & 0x0f) + 0x37;
				}
		} else {
				/* flag error */
		}
		return count;
}


int main(void)
{
		int temp = 0x00123abd;
		int tempp = 17;
		char str[] = "more older than u";

		caos_printf("I am %x years old, Your are %d years old, \nI am %s...", 
						temp, tempp, str);

		return 0;
}
